//
// JSONP-RPCスクリプト.
//

// JSONPスクリプトパターンからコールバックされるメソッド.
var _$function$_callAccessMethod = function() {
    if( __$type$script == "script" ) {
        var jargsString = $("jargs") ;
        var callbackMethod = $("callback") ;
        var id = $("jid") ;
        // ブラウザがIE以外の場合は、スクリプトタグ削除を行わない.
        if( useString( $("ie") ) == false ||
            $("ie") == "0" ) {
            id = null ;
        }
        var ret = null ;
        // 必須パラメータが設定されていない場合.
        if( useString( callbackMethod ) == false ) {
            ret = jsonpRPC.encodeJSON( jsonpRPC.createError("アクセス構成が不正です") ) ;
        }
        // 必須パラメータが設定されている場合.
        else {
            try {
                var tmp = null ;
                // 引数が設定されていない場合.
                if( useString( jargsString ) == false ) {
                    tmp = eval( "jsonpMain() ;" ) ;
                }
                // 引数が設定されている場合.
                else {
                    jargsString = jargsString.substring( 1,jargsString.length()-1 ) ;
                    tmp = eval( "jsonpMain( "+jargsString+" ) ;"  ) ;
                }
                // 実行結果が正常の場合.
                if( jsonpRPC.isError( tmp ) == false ) {
                    tmp = jsonpRPC.createSuccess( tmp ) ;
                }
                jargsString = null ;
                // １つの配列指定の場合は、配列内部を戻り値とする.
                if( valueof( tmp ) == "array" && tmp.length == 1 ) {
                    tmp = tmp[ 0 ] ;
                }
                // 文字列に変換.
                ret = jsonpRPC.encodeJSON( tmp ) ;
                tmp = null ;
            } catch( e ) {
                // 例外の場合、例外内容を返す.
                ret = jsonpRPC.encodeJSON( jsonpRPC.createError(e.toString()) ) ;
            }
        }
        // クライアントで実行する内容を生成.
        var result = "" ;
        if( useString( id ) == true ) {
            // IEの場合、スクリプトタグを、削除する処理を設定する.
            result = "document.body.removeChild($(\""+id+"\")) ;\n" ;
            id = null ;
        }
        result = result + callbackMethod + "(" + ret + ") ;\n" ;
        return result ;
    }
    return "" ;
} ;

// JSONP-RPCオブジェクト.
jsonpRPC = function() {}

// 正常結果を生成.
jsonpRPC.createSuccess = function( data ) {
    if( isNull( data ) ) {
        data = "" ;
    }
    return {"result":"success","value":data} ;
} ;

// エラーメッセージを生成.
jsonpRPC.createError = function( message ) {
    if( useString( message ) == false ) {
        message = "no message" ;
    }
    return {"result":"error","value":message} ;
} ;

// 戻り値が正常か、エラーかを判別します.
jsonpRPC.isError = function( result ) {
    if( isNull( result ) ) {
        return false ;
    }
    if( isNull( result.result ) == false &&
        result.result == "error" ) {
        return true ;
    }
    return false ;
} ;

// 戻り値データを取得.
jsonpRPC.getResult = function( data ) {
    if( isNull( data ) || isNull( data.value ) ) {
        return "" ;
    }
    return data.value ;
} ;

// json形式の文字列変換.
jsonpRPC.encodeJSON = function( data ) {
    var buf = new StrBuf() ;
    encodeJSON( data,buf ) ;
    return buf.toString() ;
} ;

